<div class="container">
    <form (ngSubmit)="savePost()" [formGroup]="postForm">

        <!-- Title -->

        <div class="form-group">
            <label for="exampleFormControlInput1">Post Title</label>
            <input type="text" 
                   class="form-control"
                   id="exampleFormControlInput1"
                   placeholder="The title of this post is..." 
                   formControlName="postMainTitle"
                    [ngClass]="{'is-invalid': 
                          (postForm.get('postMainTitle').touched || postForm.get('postMainTitle').dirty)
                          && !postForm.get('postMainTitle').valid }" />
            <span class="invalid-feedback"
                    *ngIf="postForm.get('postMainTitle').errors?.required">Each post must have a title.</span>
            <span class="invalid-feedback"
                    *ngIf="postForm.get('postMainTitle').errors?.maxlength">Post title can be up to 150 characters long.</span>
        </div>

        <!-- Subtitle -->

        <div class="form-group">
            <label for="exampleFormControlInput2">Subtitle (Optional)</label>
            <input type="text"
                   class="form-control" 
                   id="exampleFormControlInput2"
                   placeholder="The subtitle of this post is..." 
                   formControlName="postSubTitle" 
                   [ngClass]="{'is-invalid': 
                          (postForm.get('postSubTitle').touched || postForm.get('postSubTitle').dirty)
                          && !postForm.get('postSubTitle').valid }" />
            <span class="invalid-feedback"
                  *ngIf="postForm.get('postSubTitle').errors?.maxlength">Post subtitle can be up to 200 characters long.</span>
        </div>

        <!-- Lead -->

        <div class="form-group">
            <label for="postLeadControlInput">Lead</label>
            <input type="text" 
                   class="form-control"
                   id="postLeadControlInput"
                   placeholder="The lead of this post is..."
                   formControlName="postLead"
                   [ngClass]="{'is-invalid': 
                          (postForm.get('postLead').touched || postForm.get('postLead').dirty)
                          && !postForm.get('postLead').valid }" />
            <span class="invalid-feedback"
                  *ngIf="postForm.get('postLead').errors?.required">Each post must have a lead.</span>                  
            <span class="invalid-feedback"
                  *ngIf="postForm.get('postLead').errors?.maxlength">Lead can be up to 300 characters long.</span>
        </div>

        <!-- Bodytext -->

        <div class="form-group">
            <label for="exampleFormControlTextarea1">Post Bodytext</label>
            <textarea class="form-control"
                      id="exampleFormControlTextarea1"
                      rows="20"
                      formControlName="postBodytext"
                      [ngClass]="{'is-invalid': 
                             (postForm.get('postBodytext').touched || postForm.get('postBodytext').dirty)
                             && !postForm.get('postBodytext').valid }"></textarea>
            <span class="invalid-feedback"
                  *ngIf="postForm.get('postBodytext').errors?.required">Each post must have a body.</span>                  
            <span class="invalid-feedback"
                  *ngIf="postForm.get('postBodytext').errors?.maxlength">Body text can be up to 20000 characters long.</span>
        </div>

        <!-- Image -->

        <div class="form-group">
            <label for="postImageControlInput">Post image Url</label>
            <input type="url"
                   class="form-control"
                   id="postImageControlInput"
                   formControlName="postImage"
                   [ngClass]="{'is-invalid':
                          (postForm.get('postImage').touched || postForm.get('postImage').dirty)
                          && !postForm.get('postImage').valid }" />
            <span class="invalid-feedback"
                  *ngIf="postForm.get('postImage').errors?.required">Each post must have an image.</span>                  
            <span class="invalid-feedback"
                  *ngIf="postForm.get('postImage').errors?.maxlength">Image Url can be up to 500 characters long.</span>
        </div>

        <!-- Buttons -->

        <button type="button"
                class="btn btn-success"
                type="submit"
                [title]="postForm.valid ? 'Save your entered data' : 'Disabled until the form data is valid'"
                [disabled]="!postForm.valid">
            Salvesta
        </button>
        <button type="button" 
                class="btn btn-outline-warning" 
                [routerLink]="['/welcome/', post.id]">
            Tagasi
        </button>
    </form>
    <!-- <br>Dirty: {{ postForm.dirty }}
    <br>Touched: {{ postForm.touched }}
    <br>Valid: {{ postForm.valid }}
    <br>Value: {{ postForm.value | json }} -->
</div>